//
//  ImageQueue.m
//  ImageFlowViewer
//
//  Created by KUDO IKUO on 12/05/28.
//  Copyright (c) 2012年 n/a. All rights reserved.
//

#import "ImageQueue.h"

@implementation Image
    @synthesize image, index;
@end


@interface ImageQueue ()
- ( int ) searchLocatonWithIndex: ( int ) index;
@end


@implementation ImageQueue

@synthesize imageQueue;


- ( id ) init
{
    self = [ super init ];
    if( self ) {
        imageQueue = [ [ NSMutableArray alloc ] init ];
    }
    
    return self;
}

- ( int ) searchLocatonWithIndex: ( int ) index
{
    int location = -1;
    if( !imageQueue  ) return -1;
    for ( int i = 0; i < [ imageQueue count ]; i++ ) {
        Image* obj = [ imageQueue objectAtIndex: i ];
        if ( obj.index == index ) {
            location = i;
            break;
        }
    }
    
    return location;
}

- ( UIImage* ) pickupImageWithIndex: ( int ) index
{
    int location = [ self searchLocatonWithIndex: index ];
    if( location < 0 ) return nil;
    
    Image* img = [ imageQueue objectAtIndex: location ];
    return img.image;
}

- ( void ) deleteImageWithIndex: ( int ) index
{
    int location = [ self searchLocatonWithIndex: index ];
    if( location < 0 ) return;
    
    [ imageQueue removeObjectAtIndex: location ];
}

- ( void ) addImage: ( UIImage* ) image index: ( int ) index
{
    Image* img = [ [ Image alloc ] init ];
    img.image = image;
    img.index = index;
    
    [ imageQueue addObject: img ];
}

@end
