//
//  PDFDocument.m
//  PDFReader
//
//  Created by KUDO IKUO on 12/06/23.
//  Copyright (c) 2012年 n/a. All rights reserved.
//

#import "PDFDocument.h"

@implementation PDFDocument
@synthesize document, url;

- ( id ) initWithURL: ( NSURL* ) aUrl
{
    self = [ super init ];
    if( self ) {
        self.url = aUrl;
    }
    
    return self;
}



- ( UIImage* ) getPageImageWithPageNo: ( int ) pageNo
{
    if( !document ) {
        document = CGPDFDocumentCreateWithURL( (__bridge  CFURLRef ) self.url );
    }
    int size = CGPDFDocumentGetNumberOfPages (document);
    NSLog( @"pdf doc page size: %d", size );
    
   
    if( pageNo <= 0 || pageNo > size ) return nil;
    
    CGPDFPageRef pageRef = CGPDFDocumentGetPage( document, ( size_t ) pageNo );
    if( !pageRef ) return nil;
    
    CGRect frame = CGPDFPageGetBoxRect( pageRef, kCGPDFMediaBox );
    NSLog( @" page width: %f  height: %f", frame.size.width, frame.size.height );
    
    UIGraphicsBeginImageContext( frame.size );
    CGContextRef context = UIGraphicsGetCurrentContext();    
    CGContextScaleCTM( context,  1.0, -1.0 );   // 上下反転
    CGContextTranslateCTM( context, 0, -frame.size.height );
    
    CGAffineTransform transform = CGPDFPageGetDrawingTransform( pageRef, kCGPDFMediaBox,  frame,  0, YES );
    CGContextConcatCTM( context, transform );
    CGContextDrawPDFPage( context, pageRef );

    CGImageRef image =  CGBitmapContextCreateImage ( context ); 
    UIImage *img = [ [ UIImage alloc ] initWithCGImage: image ];
    UIGraphicsEndImageContext();
    
    //CGPDFDocumentRelease( document );
    //document = nil;
    
    return img;
}



@end
